<?php

namespace App\Filament\Resources;

use App\Filament\Exports\StockDataMasterExporter;
use App\Filament\Imports\StockDataMasterImporter;
use App\Filament\Resources\StockDataMasterResource\Pages;
use App\Models\Item;
use App\Models\Plant;
use App\Models\StickerMaster;
use App\Models\StockDataMaster;
use Filament\Facades\Filament;
use Filament\Forms;
use Filament\Forms\Components\DateTimePicker;
use Filament\Forms\Components\Radio;
use Filament\Forms\Components\Select;
use Filament\Forms\Components\TextInput;
use Filament\Forms\Form;
use Filament\Notifications\Notification;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Actions\ExportAction;
use Filament\Tables\Actions\ImportAction;
use Filament\Tables\Filters\Filter;
use Filament\Tables\Table;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;

class StockDataMasterResource extends Resource
{
    protected static ?string $model = StockDataMaster::class;

    protected static ?string $navigationIcon = 'heroicon-o-rectangle-stack';

    protected static ?string $navigationGroup = 'Cycle Count Software';

    public static function form(Form $form): Form
    {
        return $form
            ->schema([
                Forms\Components\Select::make('plant_id')
                    ->label('Plant')
                    ->reactive()
                    ->relationship('plant', 'name')
                    ->required(),
                Forms\Components\Select::make('sticker_master_id')
                    ->label('Item Code')
                    ->reactive()
                    ->required()
                    ->searchable()
                    ->options(function ($get) {
                        if (! $get('plant_id')) {
                            return [];
                        }

                        return StickerMaster::with('item')
                            ->where('plant_id', $get('plant_id'))
                            ->get()
                            ->pluck('item.code', 'id')
                            ->toArray();
                    }),
                Forms\Components\TextInput::make('location')
                    ->label('Location'),
                Forms\Components\TextInput::make('bin')
                    ->label('Bin'),
                Forms\Components\TextInput::make('serial_number')
                    ->label('Serial Number'),
                Forms\Components\TextInput::make('batch')
                    ->label('Batch'),
                Forms\Components\TextInput::make('quantity')
                    ->label('Quantity'),
                Forms\Components\TextInput::make('doc_no')
                    ->label('Doc No'),
                Forms\Components\Select::make('type')
                    ->label('Type')
                    ->options([
                        '0' => 'FG',
                        '1' => 'NON-FG',
                    ]),
                Forms\Components\TextInput::make('motor_scanned_status')
                    ->label('Motor Scanned Status'),
                Forms\Components\TextInput::make('pump_scanned_status')
                    ->label('Pump Scanned Status'),
                Forms\Components\TextInput::make('capacitor_scanned_status')
                    ->label('Capacitor Scanned Status'),
                Forms\Components\TextInput::make('scanned_status_set')
                    ->label('Scanned Status Set'),
                Forms\Components\TextInput::make('panel_box_item_code')
                    ->label('Panel Box Item Code'),
                Forms\Components\TextInput::make('panel_box_supplier')
                    ->label('Panel Box Supplier'),
                Forms\Components\TextInput::make('panel_box_sno')
                    ->label('Panel Box Sno'),
                Forms\Components\TextInput::make('scanned_status')
                    ->label('Scanned Status'),
                Forms\Components\TextInput::make('scanned_quantity')
                    ->label('Scanned Quantity'),
                Forms\Components\Hidden::make('created_by')
                    ->label('Created By')
                    ->default(Filament::auth()->user()?->name),
                Forms\Components\Hidden::make('updated_by')
                    ->label('Updated By')
                    ->default(Filament::auth()->user()?->name),
            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                Tables\Columns\TextColumn::make('No.')
                    ->label('No.')
                    ->getStateUsing(function ($record, $livewire, $column, $rowLoop) {
                        $paginator = $livewire->getTableRecords();
                        $perPage = method_exists($paginator, 'perPage') ? $paginator->perPage() : 10;
                        $currentPage = method_exists($paginator, 'currentPage') ? $paginator->currentPage() : 1;

                        return ($currentPage - 1) * $perPage + $rowLoop->iteration;
                    }),
                Tables\Columns\TextColumn::make('plant.name')
                    ->label('Plant')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('stickerMaster.item.code')
                    ->label('Item Code')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('type')
                    ->label('Type')
                    ->alignCenter()
                    ->searchable()
                    ->formatStateUsing(fn ($state) => match ($state) {
                        '0' => 'FG',
                        '1' => 'NON-FG',
                        default => '-',
                    })
                    ->sortable(),
                Tables\Columns\TextColumn::make('location')
                    ->label('Location')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('bin')
                    ->label('Bin')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('serial_number')
                    ->label('Serial Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('batch')
                    ->label('Batch')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('quantity')
                    ->label('Quantity')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('doc_no')
                    ->label('Document Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('motor_scanned_status')
                    ->label('Motor Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable()
                    ->visible(fn ($livewire) => ($livewire->tableFilters['advanced_filters']['type'] ?? null) != '1'),
                Tables\Columns\TextColumn::make('pump_scanned_status')
                    ->label('Pump Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable()
                    ->visible(fn ($livewire) => ($livewire->tableFilters['advanced_filters']['type'] ?? null) != '1'),
                Tables\Columns\TextColumn::make('capacitor_scanned_status')
                    ->label('Capacitor Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable()
                    ->visible(fn ($livewire) => ($livewire->tableFilters['advanced_filters']['type'] ?? null) != '1'),
                Tables\Columns\TextColumn::make('scanned_status_set')
                    ->label('Scanned Status Set')
                    ->alignCenter()
                    ->searchable()
                    ->sortable()
                    ->visible(fn ($livewire) => ($livewire->tableFilters['advanced_filters']['type'] ?? null) != '1'),
                Tables\Columns\TextColumn::make('panel_box_item_code')
                    ->label('Panel Box Item Code')
                    ->alignCenter()
                    ->searchable()
                    ->sortable()
                    ->visible(fn ($livewire) => ($livewire->tableFilters['advanced_filters']['type'] ?? null) != '1'),
                Tables\Columns\TextColumn::make('panel_box_supplier')
                    ->label('Panel Box Supplier')
                    ->alignCenter()
                    ->searchable()
                    ->sortable()
                    ->visible(fn ($livewire) => ($livewire->tableFilters['advanced_filters']['type'] ?? null) != '1'),
                Tables\Columns\TextColumn::make('panel_box_sno')
                    ->label('Panel Box Serial Number')
                    ->alignCenter()
                    ->searchable()
                    ->sortable()
                    ->visible(fn ($livewire) => ($livewire->tableFilters['advanced_filters']['type'] ?? null) != '1'),
                Tables\Columns\TextColumn::make('scanned_status')
                    ->label('Scanned Status')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('scanned_quantity')
                    ->label('Scanned Quantity')
                    ->alignCenter()
                    ->searchable()
                    ->sortable(),
                Tables\Columns\TextColumn::make('system_stock')
                    ->label('System Stock')
                    ->alignCenter()
                    ->getStateUsing(fn ($record) => $record->quantity),
                Tables\Columns\TextColumn::make('scanned_stock')
                    ->label('Scanned Stock')
                    ->alignCenter()
                    ->getStateUsing(fn ($record) => $record->scanned_quantity),
                Tables\Columns\TextColumn::make('duplicate_stock')
                    ->label('Duplicate Stock')
                    ->alignCenter()
                    ->getStateUsing(function ($record) {
                        return \App\Models\DuplicateStock::where('stock_data_master_id', $record->id)->count();
                    }),
                Tables\Columns\TextColumn::make('not_in_stock')
                    ->label('Not In Stock')
                    ->alignCenter()
                    ->getStateUsing(function ($record) {
                        return \App\Models\NotInStock::where('serial_number', $record->serial_number)
                            ->where('plant_id', $record->plant_id)
                            ->count();
                    }),
                Tables\Columns\TextColumn::make('physical_stock')
                    ->label('Physical Stock')
                    ->alignCenter()
                    ->getStateUsing(function ($record) {

                        $duplicate = \App\Models\DuplicateStock::where('stock_data_master_id', $record->id)->count();

                        $notInStock = \App\Models\NotInStock::where('serial_number', $record->serial_number)
                            ->where('plant_id', $record->plant_id)
                            ->count();

                        $scanned = $record->scanned_quantity ?? 0;

                        return $scanned + $duplicate + $notInStock;
                    }),
                Tables\Columns\TextColumn::make('stock_difference')
                    ->label('Stock Difference Count')
                    ->alignCenter()
                    ->getStateUsing(function ($record) {

                        $duplicate = \App\Models\DuplicateStock::where('stock_data_master_id', $record->id)->count();

                        $notInStock = \App\Models\NotInStock::where('serial_number', $record->serial_number)
                            ->where('plant_id', $record->plant_id)
                            ->count();

                        $scanned = (int) $record->scanned_quantity;

                        $physicalStock = $scanned + $duplicate + $notInStock;

                        $systemStock = (int) $record->quantity;

                        $difference = $physicalStock - $systemStock;

                        return max($difference, 0); // prevents negative values
                    }),
                Tables\Columns\TextColumn::make('created_at')
                    ->label('Created At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('updated_at')
                    ->label('Updated At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('deleted_at')
                    ->label('Deleted At')
                    ->alignCenter()
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                Tables\Filters\TrashedFilter::make(),
                Filter::make('advanced_filters')
                    ->label('Advanced Filters')
                    ->form([
                        Radio::make('type')
                            ->label('Stock Type')
                            ->options([
                                '0' => 'FG',
                                '1' => 'NON-FG',
                            ])
                            ->inline()
                            ->default('0')
                            ->nullable(),
                        Select::make('Plant')
                            ->label('Select Plant')
                            ->nullable()
                            ->options(function (callable $get) {
                                $userHas = Filament::auth()->user()->plant_id;

                                if ($userHas && strlen($userHas) > 0) {
                                    return Plant::where('id', $userHas)->pluck('name', 'id')->toArray();
                                } else {
                                    return Plant::whereHas('stockDataMasters', function ($query) {
                                        $query->whereNotNull('id');
                                    })->orderBy('code')->pluck('name', 'id');
                                }
                            })
                            ->reactive()
                            ->afterStateUpdated(function ($state, callable $set, callable $get): void {
                                $set('sticker_master_id', null);
                                $set('updated_by', null);
                            }),
                        TextInput::make('location')
                            ->label('Location')
                            ->placeholder(placeholder: 'Enter Location'),
                        TextInput::make('serial_number')
                            ->label('Serial Number')
                            ->placeholder(placeholder: 'Enter Serial Number'),
                        Select::make('sticker_master_id')
                            ->label('Search by Item Code')
                            ->nullable()
                            ->options(function (callable $get) {
                                $pId = $get('Plant');

                                if (empty($pId)) {
                                    return [];
                                }

                                return Item::whereHas('stickerMasters', function ($query) use ($pId) {
                                    if ($pId) {
                                        $query->where('plant_id', $pId);
                                    }
                                    // $query->whereHas('stockDataMasters');
                                })->pluck('code', 'id');
                            })
                            ->searchable()
                            ->reactive(),
                        Select::make('scanned_status')
                            ->label('Scanned Status')
                            ->nullable()
                            ->options([
                                'Scanned' => 'Scanned',
                                'Pending' => 'Pending',
                            ])
                            ->searchable()
                            ->reactive(),
                        Select::make('updated_by')
                            ->label('Created By')
                            ->nullable()
                            ->options(function (callable $get) {
                                $plantId = $get('Plant');
                                if (! $plantId) {
                                    return StockDataMaster::whereNotNull('updated_by')->select('updated_by')->distinct()->pluck('updated_by', 'updated_by');
                                } else {
                                    return StockDataMaster::where('plant_id', $plantId)->whereNotNull('updated_by')->select('updated_by')->distinct()->pluck('updated_by', 'updated_by');
                                }
                            })
                            ->searchable()
                            ->reactive(),
                        DateTimePicker::make(name: 'created_from')
                            ->label('Created From')
                            ->placeholder(placeholder: 'Select From DateTime')
                            ->reactive()
                            ->native(false),
                        DateTimePicker::make('created_to')
                            ->label('Created To')
                            ->placeholder(placeholder: 'Select To DateTime')
                            ->reactive()
                            ->native(false),
                    ])
                    ->query(function ($query, array $data) {
                        if (! isset($data['type']) && (empty($data['Plant']) && empty($data['location']) && empty($data['serial_number']) && empty($data['created_from']) && empty($data['created_to']) && empty($data['updated_by']) && empty($data['scanned_status']) && empty($data['sticker_master_id']))) {

                            if (empty($data['type'])) {
                                Notification::make()
                                    ->title('Please, choose valid type to filter.')
                                    ->danger()
                                    ->send();
                            }

                            return $query->whereRaw('1 = 0');
                        }

                        if ($data['type'] != '') {

                            if ($data['type'] == '0') {

                                $query->where('type', '0');

                                if (! empty($data['scanned_status'])) {

                                    if ($data['scanned_status'] == 'Scanned') {
                                        $query->whereNotNull('scanned_status')
                                            ->where('scanned_status', '!=', '');
                                    } elseif ($data['scanned_status'] == 'Pending') {

                                        $query->where(function ($query) {
                                            $query->whereNull('scanned_status')
                                                ->orWhere('scanned_status', '!=', 'Scanned');
                                        });

                                    }
                                }
                            } elseif ($data['type'] == '1') {
                                $query->where('type', '1')
                                    ->whereNotNull('quantity');

                                if ($data['scanned_status']) {

                                    if ($data['scanned_status'] == 'Scanned') {

                                        $query->whereNotNull('scanned_status')
                                            ->where('scanned_status', '!=', '');

                                    } elseif ($data['scanned_status'] == 'Pending') {

                                        $query->where(function ($q) {
                                            $q->whereNull('scanned_status')
                                                ->orWhere('scanned_status', '!=', 'Scanned');
                                        });
                                    }
                                }
                            }
                        } else {
                            if ($data['scanned_status']) {

                                if ($data['scanned_status'] == 'Scanned') {

                                    $query->whereNotNull('scanned_status')
                                        ->where('scanned_status', '!=', '');

                                } elseif ($data['scanned_status'] == 'Pending') {

                                    $query->where(function ($q) {
                                        $q->whereNull('scanned_status')
                                            ->orWhere('scanned_status', '!=', 'Scanned');
                                    });
                                }
                            }
                        }

                        if (! empty($data['Plant'])) { // $plant = $data['Plant'] ?? null
                            $query->where('plant_id', $data['Plant']);
                        } else {
                            $userHas = Filament::auth()->user()->plant_id;

                            if ($userHas && strlen($userHas) > 0) {
                                return $query->whereRaw('1 = 0');
                            }
                        }

                        if (! empty($data['location'])) {
                            $query->where('location', 'like', '%'.$data['location'].'%');
                        }

                        if (! empty($data['serial_number'])) {
                            $query->where('serial_number', 'like', '%'.$data['serial_number'].'%');
                        }

                        if (! empty($data['created_from'])) {
                            $query->where('created_at', '>=', $data['created_from']);
                        }

                        if (! empty($data['created_to'])) {
                            $query->where('created_at', '<=', $data['created_to']);
                        }

                        if (! empty($data['updated_by'])) {
                            $query->where('updated_by', $data['updated_by']);
                        }

                        if (! empty($data['sticker_master_id'])) {
                            $stickerMasterIds = StickerMaster::where('item_id', $data['sticker_master_id'])
                                ->pluck('id')
                                ->toArray();

                            if (! empty($stickerMasterIds)) {
                                $query->whereIn('sticker_master_id', $stickerMasterIds);
                            }
                        }
                    })
                    ->indicateUsing(function (array $data) {
                        $indicators = [];

                        if (! empty($data['Plant'])) {
                            $indicators[] = 'Plant: '.Plant::where('id', $data['Plant'])->value('name');
                        } else {
                            $userHas = Filament::auth()->user()->plant_id;

                            if ($userHas && strlen($userHas) > 0) {
                                return 'Plant: Choose plant to filter records.';
                            }
                        }

                        if (! empty($data['location'])) {
                            $indicators[] = 'Location: '.$data['location'];
                        }

                        if (! empty($data['serial_number'])) {
                            $indicators[] = 'Serial Number: '.$data['serial_number'];
                        }

                        if (! empty($data['sticker_master_id'])) {
                            $itemCode = Item::find($data['sticker_master_id'])->code ?? 'Unknown';
                            $indicators[] = 'Item Code: '.$itemCode;
                        }

                        if (! empty($data['updated_by'])) {
                            $indicators[] = 'Created By: '.$data['updated_by'];
                        }

                        if (! empty($data['created_from'])) {
                            $indicators[] = 'From: '.$data['created_from'];
                        }

                        if (! empty($data['created_to'])) {
                            $indicators[] = 'To: '.$data['created_to'];
                        }

                        if (! empty($data['scanned_status'])) {
                            $indicators[] = 'Scanned Status: '.$data['scanned_status'];
                        }

                        return $indicators;
                    }),
            ])
            ->filtersFormMaxHeight('280px')
            ->actions([
                Tables\Actions\ViewAction::make(),
                Tables\Actions\EditAction::make(),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make(),
                    Tables\Actions\ForceDeleteBulkAction::make(),
                    Tables\Actions\RestoreBulkAction::make(),
                ]),
            ])
            ->headerActions([
                ImportAction::make()
                    ->label('Import Stock Data')
                    ->color('warning')
                    ->importer(StockDataMasterImporter::class)
                    ->visible(function () {
                        return Filament::auth()->user()->can('view import stock data master');
                    }),
                ExportAction::make()
                    ->label('Export Stock Data')
                    ->color('warning')
                    ->exporter(StockDataMasterExporter::class)
                    ->visible(function () {
                        return Filament::auth()->user()->can('view export stock data master');
                    }),
            ]);
    }

    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListStockDataMasters::route('/'),
            'create' => Pages\CreateStockDataMaster::route('/create'),
            'view' => Pages\ViewStockDataMaster::route('/{record}'),
            'edit' => Pages\EditStockDataMaster::route('/{record}/edit'),
        ];
    }

    public static function getEloquentQuery(): Builder
    {
        return parent::getEloquentQuery()
            ->withoutGlobalScopes([
                SoftDeletingScope::class,
            ]);
    }
}
